#include <stdlib.h>
#include "queue.h"
 
queue *q_create(void)
{
        queue *q = malloc(sizeof(*q));
        if (!q)
            return NULL;
        q->back = NULL;
        q->front = NULL;
		q->count = 0;
		q->status = 1;
        return q;
}
 
int q_destroy(queue *q)
{
        if (!q)
                return 0;
        while (!q_isempty(q))
                q_dequeue(q);
        free(q);
        return 1;
}

int q_isfull(queue *q)
{
	qnode *new = malloc(sizeof(*new));
    if (!new)
        return 0;
    if (q == NULL)
    {
        free(new);
        return 0;
    }
	return 1;
}
 
int q_isempty(queue *q)
{
    if (q == NULL)
        return 2;
    if (!q->front)
        return 1;
    else
        return 0;
}
 
int q_enqueue(queue *q, qelem_t elem)
{
	if(!q){return 0;}
    qnode *new = malloc(sizeof(*new));
    if (!new)
            return 0;
    if (q==NULL || !elem)
		{
            free(new);
			return 0;
    }
    new->elem = elem;
    new->next = q->back;
    new->prev = NULL;
    if (q->back)
            q->back->prev = new;
    q->back = new;
    if (!q->front)
            q->front = new;
	q->count++;
    return 1;
}
 
qelem_t q_dequeue(queue *q)
{
    qnode *prev;
    qelem_t *elem;
    if (q_isempty(q))
        return NULL;
    prev = q->front->prev;
    elem = q->front->elem;
    free(q->front);
    q->front = prev;
	q->count--;
    return elem;
}

int q_size(queue *q)
{
	if (q == NULL)
		return 0;
	return q->count;
} 

qelem_t q_front(queue *q)
{
	qelem_t *elem;
	if(q == NULL)
		return NULL;
	elem = q->front->elem;
	return elem;
}